【算法day22】两数相除——给你两个整数,被除数 dividend 和除数 divisor。将两数相除,要求 不使用 乘法、除法和取余运算。

29. 两数相除

给你两个整数,被除数 dividend 和除数 divisor。将两数相除,要求 不使用 乘法、除法和取余运算。

整数除法应该向零截断,也就是截去(truncate)其小数部分。例如,8.345 将被截断为 8 ,-2.7335 将被截断至 -2 。

返回被除数 dividend 除以除数 divisor 得到的 商 。

注意:假设我们的环境只能存储 32 位 有符号整数,其数值范围是 −231, 231 − 1 。本题中,如果商 严格大于 231 − 1 ,则返回 231 − 1 ;如果商 严格小于 -231 ,则返回 -231 。

https://leetcode.cn/problems/divide-two-integers/description/

方法二、根据递归法总结进行化简

首先根据方法一里面的描述,我们已经理解 并得出了这个递归的过程,所以我们来进一步优化迭代的运算,

为了节省函数调用次数,用循环来代替递归 的过程即可

我们先找到最大的那个可以减去的数字,

然后再进行右移找尽可能大的那个可以减去的数字

有一个细节是要把整数变成负数后再进行运算,因为补码 的表示范围中,负数比正数多出来一位 ,

因此用减法运算可以减少边界判断的次数。

我在代码里使用了移位,

cpp 复制代码
maxSub <<= 1; // 被除数翻倍
// 也可以写成 maxSub+=maxSub;

上下两种写法效果和结果完全一样,

移位据说更省,

但是我想现代的编译器,应该会自己优化这样的运算。

cpp 复制代码
if (ratio == 0) {
     ratio = 1;
}

这里的判断不可以省略,

因为32/2 = (32-16-8-4-2-2)/2 +8+4+2+1+1= 8+4+2+1+1 = 16

否则会输出15,答案错误

cpp 复制代码
class Solution {
public:
    int divide(int dividend, int divisor) {
        // 处理边界情况
        if (dividend == INT_MIN && divisor == 1)
            return INT_MIN;
        if (dividend == INT_MIN && divisor == -1)
            return INT_MAX;
        if (divisor == 0)  // 除0是非法的
            return 0;

        // 两个正数,得到signal true,一正一负,都得到signal
        // false,两个负数得到signal true;
        bool signal = true;
        if (dividend > 0) {
            dividend = -dividend;
            signal = !signal;
        }
        if (divisor > 0) {
            divisor = -divisor;
            signal = !signal;
        }

        int maxSub = divisor;
        int ans = 0, ratio = 1;
        // 注意下面的计算都是负数!
        while (maxSub > dividend - maxSub) {
            maxSub <<= 1; // 被除数翻倍
            // 也可以写成 maxSub+=maxSub;
            ratio <<= 1;  // 倍率翻倍
        }
        // 先移动到最左边找到了最大的ratio
        while (dividend <= divisor) {
            // 逐步右移回去
            if (dividend - maxSub >= maxSub && dividend - maxSub <= 0) {
                ans += ratio; // 如果找到了当前合适的最大的maxSub就扣除并添加倍率
                dividend -= maxSub;
            }
            maxSub = maxSub >> 1;
            ratio = ratio >> 1;
            if (ratio == 0) {
                ratio = 1;
            }
        }
        if (!signal) {
            return -ans;
        }
        return ans;
    }
};

方法一、递归法:

例如10/3 = (10-6-3)/3+2+1 这个等式成立

所以我们应该先去找一个最小的X ,使得X*2大于等于10,可以知道X=3,6,12,24,48......这样翻倍,

由于当X = 6的时候12大于10,此时可以进行运算10-6 = 4,

运算后剩下4,再对4重复上面的过程,4-X<3可知X=3,

因此可以每次都X+=X,并且假设ans=1跟着X每次都ans+=1,

  • X=3 ,ans=1
  • X=6,ans=2;
  • X=12, ans=4;
  • X=24,ans =8 (3*8=24) 这说明这个ans就是我们要求和的值。

因此可以找到10/3的时候,ans = 2+1+0 = 3,也就是我们的10/3的答案。

cpp 复制代码
class Solution {
public:
    int divide(int dividend, int divisor) {
        if (divisor == 0) {
            return 0;
        }
        //处理特殊情况,边界情况
        if (dividend == INT_MIN && divisor == 1) {
            return INT_MIN;
        }
        if (dividend == INT_MIN && divisor == -1) {
            return INT_MAX;
        }
        // 全都变成负数,然后再做加减法
        if (dividend > 0)
            return -divide(-dividend, divisor);
        if (divisor > 0)
            return -divide(dividend, -divisor);
        if (dividend > divisor) {
            return 0;
        }
        int maxSub = divisor;
        int ans = 1; // 每次都加上这个最大的倍数
        while (dividend - maxSub <= maxSub) {
            maxSub += maxSub;
            ans += ans;
        }
        return ans + divide(dividend - maxSub, divisor);
    }
};
相关推荐
程序员清风4 分钟前
二叉搜索树:查找、插入与删除
算法
HRTOS8 分钟前
HRTOS 内核 BUG 修复:任务等待对象未初始化导致的异常唤醒问题
单片机·嵌入式硬件·算法·51单片机
XMAIPC_Robot23 分钟前
国产FPGA替代Xilinx在储能电力采集场景可行性评估与移植经验
人工智能·算法·机器学习·fpga开发·rk3588+fpga
开开心心就好28 分钟前
一元二次方程求解工具,答案带详细步骤
java·服务器·开发语言·算法·pdf·ocr·perl
Logic1011 小时前
C语言/数据结构位运算题解:异或XOR找出套碗游戏中的“幸运碗“——只出现一次的数字
c语言·数据结构·算法·数组·位运算·时间复杂度·空间复杂度
yi0111 小时前
LeetCode 3. 无重复字符的最长子串|不定长滑动窗口:什么时候更新最大值?
笔记·python·算法·leetcode·双指针·滑动窗口
y1su1 小时前
Leetcode 单调栈模板
java·开发语言·数据结构·算法·leetcode
索尔~古德曼2 小时前
CF(1400-1400&1300-1500)
算法
一只旭宝2 小时前
树的家族全景:从二叉树到 B+ 树
数据结构
爱刷碗的苏泓舒2 小时前
泰勒级数与泰勒展开:GNSS卫地距线性化、Jacobian矩阵与Hessian矩阵
线性代数·算法·矩阵·gnss·雅可比矩阵·卫地距线性化·海森矩阵